Attribute VB_Name = "Wrapper"
'====================================================================
' pas2000w.bas
'--------------------------------------------------------------------
'
' PA-S2000 Wrapper
'
'====================================================================
Option Explicit

Declare Function LoadLibrary Lib "kernel32" Alias "LoadLibraryA" (ByVal lpLibFileName As String) As Long
Declare Function FreeLibrary Lib "kernel32" (ByVal hLibModule As Long) As Long
Declare Function GetProcAddress Lib "kernel32" (ByVal hModule As Long, ByVal lpProcName As String) As Long

Global Const PAS2000_DLL_NAME = "pas2000.dll"   ' DLLt@C
Global Const PAS2000_ERR_WRAPDLL = -1           ' bp[֐G[

Dim hDLL As Long                                ' DLL nh

'--------------------------------------------------------------------
'       DLL[h(񃍁[h̓G[Ƃ)
'       
' ߂l     True
'           s False
'--------------------------------------------------------------------
Function Pas2000wDllOpen() As Boolean
    
    Pas2000wDllOpen = False
    
    If hDLL <> 0 Then Exit Function
    
    hDLL = LoadLibrary(PAS2000_DLL_NAME)
    If hDLL = 0 Then Exit Function
    
    If Pas2000wGetDllExportFunc() = False Then
        Pas2000wDllClose    ' DLLGNX|[g֐擾ɎŝDLLN[Y
        Exit Function
    End If
    
    Pas2000wDllOpen = True
    
End Function
'--------------------------------------------------------------------
'       DLLA[h(A[h̓G[Ƃ)
'       
' ߂l     True
'           s False
'--------------------------------------------------------------------
Function Pas2000wDllClose() As Boolean
    
    Pas2000wDllClose = True
    
    If hDLL = 0 Then Exit Function
    
    If FreeLibrary(hDLL) <> 0 Then hDLL = 0 Else Pas2000wDllClose = False
    
End Function
'--------------------------------------------------------------------
'       o[W擾
'       pdwDrvVer   hCõo[Wi[̈ւ̃|C^
'           pdwDllVer   DLL̃o[Wi[̈ւ̃|C^
' ߂l     True
'           s False
'--------------------------------------------------------------------
Function Pas2000wGetVersion(ByRef pdwDrvVer As Long, ByRef pdwDllVer As Long) As Boolean

    Pas2000wGetVersion = False
    
    If hDLL = 0 Then Exit Function
    
    If Pas2000GetVersion(pdwDrvVer, pdwDllVer) = 0 Then Exit Function
    
    Pas2000wGetVersion = True
    
End Function
'--------------------------------------------------------------------
'       foCX̌
'       pwDeviceNo  gpfoCX̃foCXʔԍi[̈ւ
'                       |C^
'           hWnd        DLLo郁bZ[W󂯎EBhẼnh
'           uWMBase     o郁bZ[WID̃x[Xl
' ߂l     True
'           s False
'--------------------------------------------------------------------
Function Pas2000wCreate(ByRef pwDeviceNo As Integer, ByVal hWnd As Long, ByVal uWMBase As Long) As Boolean

    Pas2000wCreate = False
    
    If hDLL = 0 Then Exit Function
    
    If Pas2000Create(pwDeviceNo, hWnd, uWMBase) = 0 Then Exit Function
    
    Pas2000wCreate = True
    
End Function
'-------------------------------------------------------------------
'       foCX̊J
'       wDeviceNo   ΏۃfoCX̃foCXʔԍ
' ߂l     True
'           s False
'-------------------------------------------------------------------
Function Pas2000wClose(ByVal wDeviceNo As Integer) As Boolean

    Pas2000wClose = False
    
    If hDLL = 0 Then Exit Function
    
    If Pas2000Close(wDeviceNo) = 0 Then Exit Function
    
    Pas2000wClose = True
    
End Function
'--------------------------------------------------------------------
'       foCX̎擾
'       wDeviceNo   ΏۃfoCX̃foCXʔԍ
'           pDevInfo    foCXi[\̂ւ̃|C^
' ߂l     True
'           s False
'--------------------------------------------------------------------
Function Pas2000wGetDevInfo(ByVal wDeviceNo As Integer, ByRef pDevInfo As TDEVINFO) As Boolean

    Pas2000wGetDevInfo = False
    
    If hDLL = 0 Then Exit Function
    
    If Pas2000GetDevInfo(wDeviceNo, pDevInfo) = 0 Then Exit Function
    
    Pas2000wGetDevInfo = True
    
End Function
'--------------------------------------------------------------------
'       TCY̎擾
'       wDeviceNo   ΏۃfoCX̃foCXʔԍ
'           pdwMemSize  Ă郁TCYi[̈ւ̃|C^
' ߂l     True
'           s False
'--------------------------------------------------------------------
Function Pas2000wGetMemSize(ByVal wDeviceNo As Integer, ByRef pdwMemSize As Long) As Boolean

    Pas2000wGetMemSize = False
    
    If hDLL = 0 Then Exit Function
    
    If Pas2000GetMemSize(wDeviceNo, pdwMemSize) = 0 Then Exit Function
    
    Pas2000wGetMemSize = True
    
End Function
'--------------------------------------------------------------------
'       TvO샂[h̐ݒ
'       wDeviceNo   ΏۃfoCX̃foCXʔԍ
'           pSetMode    ݒi[Ă\̂̃|C^
' ߂l     True
'           s False
'--------------------------------------------------------------------
Function Pas2000wSetMode(ByVal wDeviceNo As Integer, ByRef pSetMode As TSETMODE) As Boolean

    Pas2000wSetMode = False
    
    If hDLL = 0 Then Exit Function
    
    If Pas2000SetMode(wDeviceNo, pSetMode) = 0 Then Exit Function
    
    Pas2000wSetMode = True
    
End Function
'--------------------------------------------------------------------
'       TvO̊Jn
'       wDeviceNo   ΏۃfoCX̃foCXʔԍ
'           dwInitArg   \(0w)
' ߂l     True
'           s False
'--------------------------------------------------------------------
Function Pas2000wStartSampling(ByVal wDeviceNo As Integer, ByVal dwInitArg As Long) As Boolean
    
    Pas2000wStartSampling = False
    
    If hDLL = 0 Then Exit Function
    
    If Pas2000StartSampling(wDeviceNo, dwInitArg) = 0 Then Exit Function
    
    Pas2000wStartSampling = True
    
End Function
'--------------------------------------------------------------------
'       TvO̒~
'       wDeviceNo   ΏۃfoCX̃foCXʔԍ
' ߂l     True
'           s False
'--------------------------------------------------------------------
Function Pas2000wStopSampling(ByVal wDeviceNo As Integer) As Boolean

    Pas2000wStopSampling = False
    
    If hDLL = 0 Then Exit Function
    
    If Pas2000StopSampling(wDeviceNo) = 0 Then Exit Function
    
    Pas2000wStopSampling = True
    
End Function
'--------------------------------------------------------------------
'       TvOXe[^X擾
'       wDeviceNo   ΏۃfoCX̃foCXʔԍ
'           pdwStatus   TvOXe[^X
'           pdwNumData  ǃTvOf[^
'           pvInitArg   \
' ߂l     True
'           s False
'--------------------------------------------------------------------
Function Pas2000wGetStatus(ByVal wDeviceNo As Integer, ByRef pdwStatus As Long, ByRef pdwNumData As Long, ByRef pvInitArg As Long) As Boolean

    Pas2000wGetStatus = False
    
    If hDLL = 0 Then Exit Function
    
    If Pas2000GetStatus(wDeviceNo, pdwStatus, pdwNumData, pvInitArg) = 0 Then Exit Function
    
    Pas2000wGetStatus = True
    
End Function
'--------------------------------------------------------------------
'       TvOf[^擾
'       wDeviceNo   ΏۃfoCX̃foCXʔԍ
'           dwNumData   擾f[^
'           pdwData     擾f[^i[̈ւ̃|C^
' ߂l     True
'           s False
'--------------------------------------------------------------------
Function Pas2000wGetData(ByVal wDeviceNo As Integer, ByVal dwNumData As Long, ByRef pdwData() As Long) As Boolean

    Pas2000wGetData = False
    
    If hDLL = 0 Then Exit Function
    
    If Pas2000GetData(wDeviceNo, dwNumData, pdwData(LBound(pdwData))) = 0 Then Exit Function
    
    Pas2000wGetData = True
    
End Function
'--------------------------------------------------------------------
'       G[R[h̎擾
'       wDeviceNo   ΏۃfoCX̃foCXʔԍ
' ߂l    G[R[h
'--------------------------------------------------------------------
Function Pas2000wGetLastError(ByVal wDeviceNo As Integer) As Long

    Pas2000wGetLastError = PAS2000_ERR_WRAPDLL
    
    If hDLL = 0 Then Exit Function
    
    Pas2000wGetLastError = Pas2000GetLastError(wDeviceNo)
    
End Function

'--------------------------------------------------------------------
'       DLLGNX|[g֐AhX̎擾
'       
' ߂l     True
'           s False
'--------------------------------------------------------------------
Private Function Pas2000wGetDllExportFunc() As Boolean

    Dim pFunc As Long
    
    Pas2000wGetDllExportFunc = False
    
    ' Pas2000GetVersioñAhX擾
    pFunc = GetProcAddress(hDLL, "Pas2000GetVersion")
    If pFunc = 0 Then Exit Function
    ' Pas2000CreatẽAhX擾
    pFunc = GetProcAddress(hDLL, "Pas2000Create")
    If pFunc = 0 Then Exit Function
    ' Pas2000ClosẽAhX擾
    pFunc = GetProcAddress(hDLL, "Pas2000Close")
    If pFunc = 0 Then Exit Function
    ' Pas2000GetDevInfõAhX擾
    pFunc = GetProcAddress(hDLL, "Pas2000GetDevInfo")
    If pFunc = 0 Then Exit Function
    ' Pas2000GetMemSizẽAhX擾
    pFunc = GetProcAddress(hDLL, "Pas2000GetMemSize")
    If pFunc = 0 Then Exit Function
    ' Pas2000SetModẽAhX擾
    pFunc = GetProcAddress(hDLL, "Pas2000SetMode")
    If pFunc = 0 Then Exit Function
    ' Pas2000StartSampling̃AhX擾
    pFunc = GetProcAddress(hDLL, "Pas2000StartSampling")
    If pFunc = 0 Then Exit Function
    ' Pas2000StopSampling̃AhX擾
    pFunc = GetProcAddress(hDLL, "Pas2000StopSampling")
    If pFunc = 0 Then Exit Function
    ' Pas2000GetStatus̃AhX擾
    pFunc = GetProcAddress(hDLL, "Pas2000GetStatus")
    If pFunc = 0 Then Exit Function
    ' Pas2000GetDatãAhX擾
    pFunc = GetProcAddress(hDLL, "Pas2000GetData")
    If pFunc = 0 Then Exit Function
    ' Pas2000GetLastError̃AhX擾
    pFunc = GetProcAddress(hDLL, "Pas2000GetLastError")
    If pFunc = 0 Then Exit Function
    
    Pas2000wGetDllExportFunc = True ' SĂDLLGNX|[g֐AhX擾
End Function

