'===================================================================
' pas2000.vb
'-------------------------------------------------------------------
'
' PA-S2000 Wrapper
'
'===================================================================
Option Strict Off
Option Explicit On

Imports System
Imports System.Runtime.InteropServices

Public Class Pas2000

    '--------------------------------------------------------------------
    ' foCXANZXɊւ`
    '--------------------------------------------------------------------
    Public Const MAX_DEVICE As Integer = 16             ' őfoCX
    Public Const DEVICE_AUTO As Short = &HFFFFS         ' foCXw
    '--------------------------------------------------------------------
    ' `lɊւ`
    '--------------------------------------------------------------------
    Public Const NUM_CH As Integer = 2                  ' Ή`l
    Public Const CH1 As Integer = 0                     ' CH1
    Public Const CH2 As Integer = 1                     ' CH2
    '--------------------------------------------------------------------
    ' foCXɊւ`
    '--------------------------------------------------------------------
    Public Const VID_LENGTH As Integer = 8              ' x_ʕ
    Public Const PID_LENGTH As Integer = 16             ' v_Ngʕ
    '--------------------------------------------------------------------
    ' TvOXe[^X̒`
    '--------------------------------------------------------------------
    Public Const STS_STOP As Integer = &H0              ' CxgȂ(~)
    Public Const STS_PRE_TRIG As Integer = &H1          ' gK҂ɂȂȌ
    Public Const STS_WAIT_FOR_TRIG As Integer = &H3     ' gK҂̏
    Public Const STS_TRIG_DETECT As Integer = &H7       ' gK|
    Public Const STS_AUTO_RUN As Integer = &HB          ' ^CAEgt[ōăX^[g
    '--------------------------------------------------------------------
    ' G[R[h̒`
    '--------------------------------------------------------------------
    Public Const SUCCESS As Integer = 0                 ' ُȂ
    Public Const ERR_SYSTEM As Integer = 1              ' VXeG[
    Public Const ERR_NO_DEVICE As Integer = 2           ' gp\ȃfoCX܂
    Public Const ERR_IN_USE As Integer = 3              ' w̃foCX͎gpł
    Public Const ERR_INVALID_DEVICENO As Integer = 4    ' sȃfoCXʔԍł
    Public Const ERR_INVALID_ARGUMENT As Integer = 5    ' sȈw肳܂
    Public Const ERR_INTERNAL As Integer = 6            ' G[ł
    Public Const ERR_TRANSFER_TIMEOUT As Integer = 7    ' f[^]^CAEgɂȂ܂
    Public Const ERR_TRANSFER_CANCEL As Integer = 8     ' f[^]LZ܂
    Public Const ERR_TRANSFER_FAIL As Integer = 9       ' f[^]s܂
    Public Const ERR_BUFF_OVERFLOW As Integer = 10      ' obt@I[o[t[ł
    Public Const ERR_MEMSIZE As Integer = 11            ' 擾TCYُł
    Public Const ERR_DEVICE As Integer = 12             ' foCXG[ł
    '--------------------------------------------------------------------
    ' bZ[W̒`
    '--------------------------------------------------------------------
    Public Const WM_DATA_READY As Integer = 1           ' `f[^
    Public Const WM_DATA_THREAD_ERROR As Integer = 2    ' f[^擾pXbhG[
    '--------------------------------------------------------------------
    ' ̑̒`
    '--------------------------------------------------------------------
    Public Const DEVICE_ID As Integer = &H5320          ' foCXID
    Public Const RES_VERT As Integer = 1024             ' \(1024|Cg)
    Public Const RES_VOLTPOS As Integer = 500           ' d|WV\
    Public Const ADBUFF_MAX_SIZE As Integer = 1000000   ' ݍőf[^
    Public Const ADDATA_MASK_BIT As Integer = &H3FF     ' rbg}XN
    '--------------------------------------------------------------------
    ' eݒl̒`
    '--------------------------------------------------------------------
    ' (d)XP[
    Public Const VOLTDIV_0 As Integer = 0               ' 10mV  or 100mV
    Public Const VOLTDIV_1 As Integer = 1               ' 20mV  or 200mV
    Public Const VOLTDIV_2 As Integer = 2               ' 50mV  or 500mV
    Public Const VOLTDIV_3 As Integer = 3               ' 100mV or 1V
    Public Const VOLTDIV_4 As Integer = 4               ' 200mV or 2V
    Public Const VOLTDIV_5 As Integer = 5               ' 500mV or 5V
    Public Const VOLTDIV_6 As Integer = 6               ' 1V    or 10V
    Public Const VOLTDIV_7 As Integer = 7               ' 2V    or 20V
    ' v[u
    Public Const PROBE_X1 As Integer = 1                ' 1:1
    Public Const PROBE_X10 As Integer = 10              ' 10:1
    Public Const PROBE_X100 As Integer = 100            ' 100:1
    ' ͌
    Public Const CUP_DC As Integer = 0                  ' DC
    Public Const CUP_AC As Integer = 1                  ' AC
    ' TCY
    Public Const MEMSIZE_10K As Integer = 0             ' 10kPoint
    Public Const MEMSIZE_100K As Integer = 1            ' 100kPoint
    Public Const MEMSIZE_1M As Integer = 2              ' 1MPoint
    ' ()XP[
    Public Const TIMEDIV_10NS As Integer = 10           ' 10ns
    Public Const TIMEDIV_20NS As Integer = 20           ' 20ns
    Public Const TIMEDIV_50NS As Integer = 50           ' 50ns
    Public Const TIMEDIV_100NS As Integer = 100         ' 100ns
    Public Const TIMEDIV_200NS As Integer = 200         ' 200ns
    Public Const TIMEDIV_500NS As Integer = 500         ' 500ns
    Public Const TIMEDIV_1US As Integer = 1000          ' 1us
    Public Const TIMEDIV_2US As Integer = 2000          ' 2us
    Public Const TIMEDIV_5US As Integer = 5000          ' 5us
    Public Const TIMEDIV_10US As Integer = 10000        ' 10us
    Public Const TIMEDIV_20US As Integer = 20000        ' 20us
    Public Const TIMEDIV_50US As Integer = 50000        ' 50us
    Public Const TIMEDIV_100US As Integer = 100000      ' 100us
    Public Const TIMEDIV_200US As Integer = 200000      ' 200us
    Public Const TIMEDIV_500US As Integer = 500000      ' 500us
    Public Const TIMEDIV_1MS As Integer = 1000000       ' 1ms
    Public Const TIMEDIV_2MS As Integer = 2000000       ' 2ms
    Public Const TIMEDIV_5MS As Integer = 5000000       ' 5ms
    Public Const TIMEDIV_10MS As Integer = 10000000     ' 10ms
    ' gш
    Public Const BW_FULL As Integer = 0                 ' FULL
    Public Const BW_20MHZ As Integer = 1                ' 20MHz
    ' TvO[h
    Public Const SMP_REAL As Integer = 0                ' ATvO
    Public Const SMP_EQU As Integer = 1                 ' TvO
    ' ANCWV[h
    Public Const ACQ_SINGLE As Integer = 0              ' VOVbg
    Public Const ACQ_ROLL As Integer = 1                ' [
    ' gK[h
    Public Const TMODE_AUTO As Integer = 0              ' I[g
    Public Const TMODE_NORMAL As Integer = 1            ' m[}
    Public Const TMODE_FREERUN As Integer = 2           ' t[
    ' gK\[X
    Public Const TSRC_CH1 As Integer = 0                ' CH1
    Public Const TSRC_CH2 As Integer = 1                ' CH2
    Public Const TSRC_EXT As Integer = 2                ' O
    ' gK͌
    Public Const TCUP_DC As Integer = 0                 ' DC
    Public Const TCUP_LF As Integer = 1                 ' LFrej
    Public Const TCUP_HF As Integer = 2                 ' HFrej
    ' gKX[v
    Public Const TSLP_POS As Integer = 0                ' (オ)
    Public Const TSLP_NEG As Integer = 1                ' ()
    ' pXgK(pX)
    Public Const PULSE_NONE As Integer = 0              ' gp
    Public Const PULSE_UNDER As Integer = 1             ' pX
    Public Const PULSE_ABOVE As Integer = 2             ' pXȏ

    '--------------------------------------------------------------------
    ' foCX\
    '--------------------------------------------------------------------
    Public Structure TDEVINFO
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=VID_LENGTH)> _
        Dim VendorID() As Byte                          ' x_ʕ
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=PID_LENGTH)> _
        Dim ProductID() As Byte                         ' v_Ngʕ
        Dim FirmVer As Byte                             ' t@[EFÃo[W
        Dim FpgaVer As Byte                             ' FPGÃo[W
    End Structure
    '--------------------------------------------------------------------
    ' TvOp[^\
    '--------------------------------------------------------------------
    Public Structure TSETMODE
        ' ݒ
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=NUM_CH)> _
        Dim dwVoltDiv() As Integer                      ' (d)XP[
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=NUM_CH)> _
        Dim dwVoltPos() As Integer                      ' (d)|WV
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=NUM_CH)> _
        Dim dwVertCoupling() As Integer                 ' (d)͌

        ' ݒ
        Dim dwMemSize As Integer                        ' TCY
        Dim dwSamplingTime As Integer                   ' ()XP[
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=NUM_CH)> _
        Dim dwBandWidth() As Integer                    ' gш
        Dim dwSamplingMode As Integer                   ' TvO[h
        Dim dwAcqMode As Integer                        ' ANCWV[h

        ' gKݒ
        Dim dwTrigMode As Integer                       ' gK[h
        Dim dwTrigSource As Integer                     ' gK\[X
        Dim dwTrigCoupling As Integer                   ' gK͌
        Dim dwTrigSlope As Integer                      ' gKX[v
        Dim dwTrigLevel As Integer                      ' gKx
        Dim dwTrigPos As Integer                        ' gK|WV
        Dim dwTrigDelay As Integer                      ' gKfBC
        Dim dwTrigPulse As Integer                      ' pXgK(pX)
        Dim dwTrigPulseWidth As Integer                 ' pXgK(pX)
    End Structure

    '--------------------------------------------------------------------
    ' API
    '--------------------------------------------------------------------
    ' o[W擾
    <DllImport("pas2000.dll")> _
    Public Shared Function Pas2000GetVersion(ByRef pdwDrvVer As Integer, ByRef pdwDllVer As Integer) As Boolean
    End Function

    ' foCX̌
    <DllImport("pas2000.dll")> _
    Public Shared Function Pas2000Create(ByRef pwDeviceNo As Short, _
                                            ByVal hWnd As Integer, ByVal uWMBase As Integer) As Boolean
    End Function

    ' foCX̊J
    <DllImport("pas2000.dll")> _
    Public Shared Function Pas2000Close(ByVal wDeviceNo As Short) As Boolean
    End Function

    ' foCX擾
    <DllImport("pas2000.dll")> _
    Public Shared Function Pas2000GetDevInfo(ByVal wDeviceNo As Short, ByRef pDevInfo As TDEVINFO) As Boolean
    End Function

    ' TCY擾
    <DllImport("pas2000.dll")> _
    Public Shared Function Pas2000GetMemSize(ByVal wDeviceNo As Short, ByRef pdwMemSize As Integer) As Boolean
    End Function

    ' TvO샂[h̐ݒ
    <DllImport("pas2000.dll")> _
    Public Shared Function Pas2000SetMode(ByVal wDeviceNo As Short, ByRef pSetMode As TSETMODE) As Boolean
    End Function

    ' TvOJn
    <DllImport("pas2000.dll")> _
    Public Shared Function Pas2000StartSampling(ByVal wDeviceNo As Short, ByVal dwInitArg As Integer) As Boolean
    End Function

    ' TvO~
    <DllImport("pas2000.dll")> _
    Public Shared Function Pas2000StopSampling(ByVal wDeviceNo As Short) As Boolean
    End Function

    ' TvOXe[^X擾
    <DllImport("pas2000.dll")> _
    Public Shared Function Pas2000GetStatus(ByVal wDeviceNo As Short, ByRef pdwStatus As Integer, _
                                            ByRef pdwNumData As Integer, ByRef pvInitArg As Integer) As Boolean
    End Function

    ' TvOf[^擾
    <DllImport("pas2000.dll")> _
    Public Shared Function Pas2000GetData(ByVal wDeviceNo As Short, ByVal dwNumData As Integer, ByRef pdwData As Integer) As Boolean
    End Function

    ' G[R[h
    <DllImport("pas2000.dll")> _
    Public Shared Function Pas2000GetLastError(ByVal wDeviceNo As Short) As Integer
    End Function

    '--------------------------------------------------------------------
    '       o[W擾
    '       pdwDrvVer   hCõo[Wi[̈ւ̃|C^
    '           pdwDllVer   DLL̃o[Wi[̈ւ̃|C^
    ' ߂l     True
    '           s False
    '--------------------------------------------------------------------
    Public Function GetVersion(ByRef pdwDrvVer As Integer, ByRef pdwDllVer As Integer) As Boolean

        GetVersion = Pas2000GetVersion(pdwDrvVer, pdwDllVer)

    End Function
    '--------------------------------------------------------------------
    '       foCX̌
    '       pwDeviceNo  gpfoCX̃foCXʔԍi[̈ւ
    '                       |C^
    '           hWnd        DLLo郁bZ[W󂯎EBhẼnh
    '           uWMBase     o郁bZ[WID̃x[Xl
    ' ߂l     True
    '           s False
    '--------------------------------------------------------------------
    Public Function Create(ByRef pwDeviceNo As Short, ByVal hWnd As Integer, ByVal uWMBase As Integer) As Boolean

        Create = Pas2000Create(pwDeviceNo, hWnd, uWMBase)

    End Function
    '-------------------------------------------------------------------
    '       foCX̊J
    '       wDeviceNo   ΏۃfoCX̃foCXʔԍ
    ' ߂l     True
    '           s False
    '-------------------------------------------------------------------
    Public Function Close(ByVal wDeviceNo As Short) As Boolean

        Close = Pas2000Close(wDeviceNo)

    End Function
    '--------------------------------------------------------------------
    '       foCX̎擾
    '       wDeviceNo   ΏۃfoCX̃foCXʔԍ
    '           pDevInfo    foCXi[\̂ւ̃|C^
    ' ߂l     True
    '           s False
    '--------------------------------------------------------------------
    Public Function GetDevInfo(ByVal wDeviceNo As Short, ByRef pDevInfo As TDEVINFO) As Boolean

        GetDevInfo = Pas2000GetDevInfo(wDeviceNo, pDevInfo)

    End Function
    '--------------------------------------------------------------------
    ' TCY̎擾
    '       wDeviceNo   ΏۃfoCX̃foCXʔԍ
    '           pdwMemSize  Ă郁TCYi[̈ւ̃|C^
    ' ߂l     True
    '           s False
    '--------------------------------------------------------------------
    Public Function GetMemSize(ByVal wDeviceNo As Short, ByRef pdwMemSize As Integer) As Boolean

        GetMemSize = Pas2000GetMemSize(wDeviceNo, pdwMemSize)

    End Function
    '--------------------------------------------------------------------
    '       TvO샂[h̐ݒ
    '       wDeviceNo   ΏۃfoCX̃foCXʔԍ
    '           pSetMode    TvOp[^̃|C^
    ' ߂l     True
    '           s False
    '--------------------------------------------------------------------
    Public Function SetMode(ByVal wDeviceNo As Short, ByRef pSetMode As TSETMODE) As Boolean

        SetMode = Pas2000SetMode(wDeviceNo, pSetMode)

    End Function
    '--------------------------------------------------------------------
    '       TvO̊Jn
    '       wDeviceNo   ΏۃfoCX̃foCXʔԍ
    '           dwInitArg   \(0w)
    ' ߂l     True
    '           s False
    '--------------------------------------------------------------------
    Public Function StartSampling(ByVal wDeviceNo As Short, ByVal dwInitArg As Integer) As Boolean

        StartSampling = Pas2000StartSampling(wDeviceNo, dwInitArg)

    End Function
    '--------------------------------------------------------------------
    '       TvO̒~
    '       wDeviceNo   ΏۃfoCX̃foCXʔԍ
    ' ߂l     True
    '           s False
    '--------------------------------------------------------------------
    Public Function StopSampling(ByVal wDeviceNo As Short) As Boolean

        StopSampling = Pas2000StopSampling(wDeviceNo)

    End Function
    '--------------------------------------------------------------------
    '       TvOXe[^X擾
    '       wDeviceNo   ΏۃfoCX̃foCXʔԍ
    '           pdwStatus   TvOXe[^X
    '           pdwNumData  ǃTvOf[^
    '           pvInitArg   \
    ' ߂l     True
    '           s False
    '--------------------------------------------------------------------
    Public Function GetStatus(ByVal wDeviceNo As Short, ByRef pdwStatus As Integer, _
                                ByRef pdwNumData As Integer, ByRef pvInitArg As Integer) As Boolean

        GetStatus = Pas2000GetStatus(wDeviceNo, pdwStatus, pdwNumData, pvInitArg)

    End Function
    '--------------------------------------------------------------------
    '       TvOf[^擾
    '       wDeviceNo   ΏۃfoCX̃foCXʔԍ
    '           dwNumData   擾f[^
    '           pdwData     擾f[^i[̈ւ̃|C^
    ' ߂l     True
    '           s False
    '--------------------------------------------------------------------
    Public Function GetData(ByVal wDeviceNo As Short, ByVal dwNumData As Integer, ByRef pdwData() As Integer) As Boolean

        GetData = Pas2000GetData(wDeviceNo, dwNumData, pdwData(LBound(pdwData)))

    End Function
    '--------------------------------------------------------------------
    '       G[R[h̎擾
    '       wDeviceNo   ΏۃfoCX̃foCXʔԍ
    ' ߂l    G[R[h
    '--------------------------------------------------------------------
    Public Function GetLastError(ByVal wDeviceNo As Short) As Integer

        GetLastError = Pas2000GetLastError(wDeviceNo)

    End Function

End Class
